<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Sed</title>
<meta name="author" content="dt" />
<meta name="description" content="Knowledge Base - Sed
Header
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<script type="text/x-mathjax-config">
    MathJax.Hub.Config({
        displayAlign: "center",
        displayIndent: "0em",

        "HTML-CSS": { scale: 100,
                        linebreaks: { automatic: "false" },
                        webFont: "TeX"
                       },
        SVG: {scale: 100,
              linebreaks: { automatic: "false" },
              font: "TeX"},
        NativeMML: {scale: 100},
        TeX: { equationNumbers: {autoNumber: "AMS"},
               MultLineWidth: "85%",
               TagSide: "right",
               TagIndent: ".8em"
             }
});
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0/MathJax.js?config=TeX-AMS_HTML"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Sed</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org3ab11cc">What is sed?</a></li>
<li><a href="#orgb5040b1">s for substitution</a>
<ul>
<li><a href="#org4834757">Replace the first occurrence of a regular expression in each line of a file:</a></li>
<li><a href="#orgf2cde4e">Replace all occurrences of a regular expression in a file:</a></li>
<li><a href="#org5e5c919">Replace all occurrences of a string in a file, overwriting the file (i.e. in-place):</a></li>
<li><a href="#orgedba005">Replace only on lines matching the line pattern:</a></li>
<li><a href="#org50adbaf">Delete lines matching the line pattern:</a></li>
<li><a href="#org7bce1f2">Apply multiple find-replace expressions to a file:</a></li>
<li><a href="#org6ab0e0a">Replace separator `/` by any other character not used in the find or replace patterns, e.g., `#`:</a></li>
<li><a href="#org4394348">Print only the lines containing the search string</a></li>
<li><a href="#orgda31dd2">PRO TIPS: Delete all spaces tabs at end of every line</a>
<ul>
<li><a href="#orgaa2ac4d">Spaces</a></li>
<li><a href="#orgfb95a40">Tabs</a></li>
</ul>
</li>
<li><a href="#orgd9a300e">Delete empty lines</a></li>
<li><a href="#org29fe94b">Change lowercase to uppercase and vice versa:</a></li>
<li><a href="#org5c53804">Print the first 11 lines of a file:</a>
<ul>
<li><a href="#orgf9f30a0">Footer</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org3ab11cc" class="outline-2">
<h2 id="org3ab11cc">What is sed?</h2>
<div class="outline-text-2" id="text-org3ab11cc">
<p>
Sed is a &ldquo;stream editor&rdquo; for filtering and transforming text.  In short, it&rsquo;s an editor for modifying files automatically.  So if you want to write a script that makes changes in a file, sed is the tool that you probably want to use for that.
</p>
</div>
</div>
<div id="outline-container-orgb5040b1" class="outline-2">
<h2 id="orgb5040b1">s for substitution</h2>
<div class="outline-text-2" id="text-orgb5040b1">
<p>
While sed has a ton of commands, most people only learn the &rsquo;s&rsquo; command.  And it&rsquo;s understandable why that&rsquo;s the case.  The &rsquo;s&rsquo; command (substitution) is so useful.  Let me show an example:
</p>
</div>
<div id="outline-container-org4834757" class="outline-3">
<h3 id="org4834757">Replace the first occurrence of a regular expression in each line of a file:</h3>
<div class="outline-text-3" id="text-org4834757">
<ul class="org-ul">
<li>sed s/find/replace/ &lt;oldfile &gt;newfile</li>
<li>sed s/red/green/ &lt;.Xresources &gt;sed-test</li>
<li>sed s/red/green/ .Xresources &gt;sed-test (also works)</li>
<li>echo &ldquo;Derek&rdquo; | sed &rsquo;s/Derek/DT/&rsquo;</li>
<li>echo &ldquo;The Emacs file manager is dired&rdquo; | sed &rsquo;s/red/green/&rsquo;</li>
</ul>
</div>
</div>
<div id="outline-container-orgf2cde4e" class="outline-3">
<h3 id="orgf2cde4e">Replace all occurrences of a regular expression in a file:</h3>
<div class="outline-text-3" id="text-orgf2cde4e">
<ul class="org-ul">
<li>sed &rsquo;s/regularexpression/replacement/g&rsquo; filename</li>
<li>man sed | sed &rsquo;s/sed/SED/g&rsquo; | less</li>
<li>man sed | sed &rsquo;s/ sed /SED/g&rsquo; | less</li>
</ul>
</div>
</div>
<div id="outline-container-org5e5c919" class="outline-3">
<h3 id="org5e5c919">Replace all occurrences of a string in a file, overwriting the file (i.e. in-place):</h3>
<div class="outline-text-3" id="text-org5e5c919">
<ul class="org-ul">
<li>sed -i &rsquo;s/find/replace/g&rsquo; filename</li>
<li>sed -i &rsquo;s/Taylor/Tyler/g&rsquo; .bashrc</li>
<li>sed -i &rsquo;s/Tyler/Taylor/g&rsquo; .bashrc</li>
</ul>
</div>
</div>
<div id="outline-container-orgedba005" class="outline-3">
<h3 id="orgedba005">Replace only on lines matching the line pattern:</h3>
<div class="outline-text-3" id="text-orgedba005">
<ul class="org-ul">
<li>tldr sed | sed &rsquo;/Replace/s/the/THE /&rsquo;</li>
</ul>
</div>
</div>
<div id="outline-container-org50adbaf" class="outline-3">
<h3 id="org50adbaf">Delete lines matching the line pattern:</h3>
<div class="outline-text-3" id="text-org50adbaf">
<ul class="org-ul">
<li>tldr sed | sed &rsquo;/line_pattern/d&rsquo;</li>
</ul>
</div>
</div>
<div id="outline-container-org7bce1f2" class="outline-3">
<h3 id="org7bce1f2">Apply multiple find-replace expressions to a file:</h3>
<div class="outline-text-3" id="text-org7bce1f2">
<ul class="org-ul">
<li>sed -e &rsquo;s/find/replace/&rsquo; -e &rsquo;s/find/replace/&rsquo; filename</li>
<li>cat /etc/shells | sed -e &rsquo;s/usr/u/g&rsquo; -e &rsquo;s/bin/b/g&rsquo;</li>
</ul>
</div>
</div>
<div id="outline-container-org6ab0e0a" class="outline-3">
<h3 id="org6ab0e0a">Replace separator `/` by any other character not used in the find or replace patterns, e.g., `#`:</h3>
<div class="outline-text-3" id="text-org6ab0e0a">
<ul class="org-ul">
<li>sed &rsquo;s#find#replace#&rsquo; filename</li>
<li>cat /etc/shells | sed -e &rsquo;s|usr|u|g&rsquo; -e &rsquo;s#bin#b#g&rsquo;</li>
</ul>
</div>
</div>
<div id="outline-container-org4394348" class="outline-3">
<h3 id="org4394348">Print only the lines containing the search string</h3>
<div class="outline-text-3" id="text-org4394348">
<ul class="org-ul">
<li>cat /etc/shells | sed -n &rsquo;/usr/p&rsquo;</li>
</ul>
</div>
</div>
<div id="outline-container-orgda31dd2" class="outline-3">
<h3 id="orgda31dd2">PRO TIPS: Delete all spaces tabs at end of every line</h3>
<div class="outline-text-3" id="text-orgda31dd2">
</div>
<div id="outline-container-orgaa2ac4d" class="outline-4">
<h4 id="orgaa2ac4d">Spaces</h4>
<div class="outline-text-4" id="text-orgaa2ac4d">
<pre class="example" id="org87577d1">
sed -i 's/ *$//' test.sh
</pre>
</div>
</div>
<div id="outline-container-orgfb95a40" class="outline-4">
<h4 id="orgfb95a40">Tabs</h4>
<div class="outline-text-4" id="text-orgfb95a40">
<pre class="example" id="org97c3b0a">
sed -i 's/[[:space:]]*$//' test.sh
</pre>
</div>
</div>
</div>
<div id="outline-container-orgd9a300e" class="outline-3">
<h3 id="orgd9a300e">Delete empty lines</h3>
<div class="outline-text-3" id="text-orgd9a300e">
<ul class="org-ul">
<li>cat test.sh | sed &rsquo;/^$/d&rsquo;</li>
</ul>
</div>
</div>
<div id="outline-container-org29fe94b" class="outline-3">
<h3 id="org29fe94b">Change lowercase to uppercase and vice versa:</h3>
<div class="outline-text-3" id="text-org29fe94b">
<ul class="org-ul">
<li>sed &rsquo;s/[a-z]/\U&amp;/g&rsquo; test.sh</li>
<li>sed &rsquo;s/[A-Z]/\L&amp;/g&rsquo; test.sh</li>
</ul>
</div>
</div>
<div id="outline-container-org5c53804" class="outline-3">
<h3 id="org5c53804">Print the first 11 lines of a file:</h3>
<div class="outline-text-3" id="text-org5c53804">
<ul class="org-ul">
<li>sed 11q filename (head replacement)</li>
<li>awk &rsquo;NR &lt; 12&rsquo;  (NR is # of lines seen so far)</li>
<li>head -11</li>
</ul>
</div>

<div id="outline-container-orgf9f30a0" class="outline-4">
<h4 id="orgf9f30a0">Footer</h4>
<div class="outline-text-4" id="text-orgf9f30a0">
<p>
Copyright © 2020-2021 Derek Taylor (DistroTube)
</p>

<p>
This page is licensed under a <a href="https://creativecommons.org/licenses/by-nd/4.0/">Creative Commons Attribution-NoDerivatives 4.0 International License</a> (CC-BY-ND 4.0).
</p>

<p>
The source code for distro.tube can be found on <a href="https://gitlab.com/dwt1/distro.tube">GitLab</a>.  User-submitted contributions to the site are welcome, as long as the contributor agrees to license their submission with the CC-BY-ND 4.0 license.
</p>
</div>
</div>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
